Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim DS As New Data.DataSet

        DS = GetDataSet()

        FillSpread(DS)
    End Sub

    Private Function GetDataSet() As Data.DataSet
        Dim DS As New DataSet("DS")
        Dim DSTable As DataTable
        Dim DSRow As DataRow
        Dim SizeFamily As String
        Dim Empty As Object
        Dim NonEmpty As Decimal

        ' Add the new table
        DSTable = DS.Tables.Add("DS")

        ' Define the columns
        With DSTable
            .Columns.Add("Size_Family", GetType(String))
            .Columns.Add("# of empty tanks", GetType(Integer))
            .Columns.Add("# of non-empty tanks", GetType(Integer))
        End With

        ' Create rows
        For i As Integer = 1 To 42
            SizeFamily = CStr(i * 100.5)
            If i < 20 Then
                Empty = System.DBNull.Value ' the null values here cause the sluggish scrolling behavior
                NonEmpty = i * 3
            Else
                Empty = i * 2
                NonEmpty = i * 0.5
            End If
            DSRow = DSTable.NewRow
            With DSRow
                .Item("Size_Family") = SizeFamily
                .Item("# of empty tanks") = Empty
                .Item("# of non-empty tanks") = NonEmpty
            End With

            ' Add it
            DSTable.Rows.Add(DSRow)
        Next i

        GetDataSet = DS

    End Function

    Private Sub FillSpread(ByVal DS As Data.DataSet)
        Dim series1 As New FarPoint.Win.Chart.BarSeries
        Dim series2 As New FarPoint.Win.Chart.BarSeries(series1)
        Dim series As New FarPoint.Win.Chart.ClusteredBarSeries()
        Dim label As New FarPoint.Win.Chart.LabelArea()
        Dim model As New FarPoint.Win.Chart.ChartModel()
        Dim plotArea As New FarPoint.Win.Chart.YPlotArea()
        Dim ChartHeight As Integer

        label.Text = "Empty / Non-Empty Tanks by Size Family"
        label.Location = New PointF(0.5F, 0.02F)
        label.AlignmentX = 0.9F
        label.AlignmentY = 0.0F

        series1.Values.DataSource = DS.Tables(0)
        series1.Values.DataField = DS.Tables(0).Columns(1).ColumnName
        series1.CategoryNames.DataSource = DS.Tables(0)
        series1.CategoryNames.DataField = DS.Tables(0).Columns(0).ColumnName
        series1.LabelNumberFormat = "#,##0"
        series1.LabelVisible = True

        series2.Values.DataSource = DS.Tables(0)
        series2.Values.DataField = DS.Tables(0).Columns(2).ColumnName
        series2.CategoryNames.DataSource = DS.Tables(0)
        series2.CategoryNames.DataField = DS.Tables(0).Columns(0).ColumnName
        series2.LabelNumberFormat = "#,##0"
        series2.LabelVisible = True

        series.Series.Add(series1)
        series.Series.Add(series2)

        Dim legend As New FarPoint.Win.Chart.LegendArea()
        legend.Location = New PointF(0.75F, 0.05F)
        legend.AlignmentX = 1.0F
        legend.AlignmentY = 0.5F

        plotArea.Location = New PointF(0.1, 0.05F)
        plotArea.Size = New SizeF(0.6F, 0.6F)
        plotArea.Series.Add(series)
        plotArea.Vertical = False

        model.LabelAreas.Add(label)
        model.PlotAreas.Add(plotArea)
        model.LegendAreas.Add(legend)

        FpSpread1.ActiveSheet.ColumnHeader.Visible = False
        FpSpread1.ActiveSheet.RowHeader.Visible = False
        FpSpread1.ActiveSheet.PrintInfo.UseMax = False

        ChartHeight = DS.Tables(0).Rows.Count * 50

        FpSpread1_Sheet1_SpreadChart1.Size = New Size(1000, ChartHeight)
        FpSpread1_Sheet1_SpreadChart1.Model = model
    End Sub
End Class
